/*********************************************DEMONE DNS******************************************** 
							     Thu Jan  7 17:30:00 1999
DEMONE NS non concorrente di tipo UDP 
 */
/*#define __USE_BSD*/
#define DNSPORT	 32001
#define DNSPORT2 32000

#define NSERVMAX 20 /* Numero max di server ammessi*/
#define BUFS 3000
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <signal.h>
 /*Invece di signal.h posso usare <bsd/signal.h> 
in questo modo gestisco i segnali come inBSD sotto LINUX*/

/*Struttura che contiene le informazioni di ogni server*/
typedef struct
    {
    char * nome;
    unsigned long int  addr;
    unsigned short int	port;
    int count;
    } fil;


int s,porta;
struct hostent *hp,*hfiliale; /*Puntatore all'host remoto*/
struct sockaddr_in myaddr_in; /* Socket address locale*/
struct sockaddr_in peeraddr_in; 
unsigned long int indfiliale;
fil * tabella_server[NSERVMAX]; /*Tabella di dieci elementi che contengono puntatori a fil;*/
fil  *fil1;
char buf[BUFS];



main(argc,argv)
int argc; char **argv;
{
int addrlen,len,i;

/* Azzera le strutture degli indirizzi*/
memset((char *)&myaddr_in,0,sizeof(struct sockaddr_in));
memset((char *)&peeraddr_in,0,sizeof(struct sockaddr_in));
for (i=0;i<NSERVMAX;i++) tabella_server[i]=NULL;

/* Assegnazioni per la struttura di listen della socket*/
peeraddr_in.sin_family=AF_INET;

/*OSS: Il server ascolta su qualunque interfaccia di rete, invece che su una in 
particolare: utile nel caso di piu' schede di rete*/
myaddr_in.sin_addr.s_addr=INADDR_ANY;

/*Assegniamo la porta di richiesta*/
myaddr_in.sin_port=htons(DNSPORT);

/*Creiamo la socket di ascolto.*/
s=socket(AF_INET,SOCK_DGRAM,0);
if (s==-1)
    {
    perror(argv[0]);
    fprintf(stderr,"%s:impossibile creare la socket.\n",argv[0]);
    exit(1);
    }

/* Colleghiamo la socket all'indirizzo fisico */
if (bind(s,&myaddr_in,sizeof(struct sockaddr_in))==-1)
    {
    perror(argv[0]);
    fprintf(stderr,"%s: impossibile eseguire il collegamento.\n",argv[0]);
    exit(1);
    }
    
/*Creiamo un processo demone*/
setsid();

switch(fork())
    {
    case -1: /*Impossibile creare il processo figlio. */
    perror(argv[0]);
    fprintf(stderr,"%s:Impossibile creare un daemon.\n",argv[0]);
    exit(1);
    
    case 0: /* Figlio: creiamo un daemon */
    close(stdin);
    /*close(stderr);*/
    signal(SIGCLD,SIG_IGN); /*Ignoro i SIGCHILD*/
    for(;;) {
		addrlen=sizeof(struct sockaddr_in);
		if((len=recvfrom(s,buf,sizeof(buf),0,&peeraddr_in,&addrlen))==-1)
		    { 
		    printf("Errore nella RECVFROM\n");
		    }
		    else	server();/* Per ogni chiamata viene invocata la funzione server x gestire il servizio*/								    
		} /* Fine del for*/
    default: /*Il processo padre esce e lascia libera la console*/
    exit(0);
    }
}

/* Procedura server()*/
/*Il pacchetto di ricezione che arriva dai processi terminali o server ha la seguente struttura:
1) il primo int contiene il servizio richiesto e puo'  assumere i seguenti valori:
	    1 Registrazione server
	    2 Cancellazione server
	    3 Risoluzione nome logico
	    5 Richiesta di accesso esclusivo al database
2) Segue una stringa di dati terminata '\0' che contiene le informazioni ricevute.
3) Segue un intero con la Porta del servizio.
*/
	     

server()
{
/*Decodifica dell'azione richiesta*/
switch(atoi(&buf[0]))
    {
    case 1:regserver();
		break;
    case 2:cancserv();
		break;
    case 3:query_terminale();
		break;
    case 5:chiudi_dbf();
		break;
    default: return(1);/*Ignora la richiesta*/
    }
}

/*Funzione di registrazione del server*/
/* Creo una struttura che contenga ordinatamente l'indirizzo dell'host da restituire e la sua porta*/
regserver()
{
int pos;
pos=0;

/*Ricerca posizione nella tabella*/
while((tabella_server[pos]!=NULL)&&(pos<NSERVMAX)) pos++;
if (pos==NSERVMAX) {
			printf("Spazio nella tabella esaurito!\n");
			return(1);
			}
/*Alloco la entry nella tabella*/
tabella_server[pos]=(fil *)malloc(sizeof(fil));
/*riempio i campi*/
tabella_server[pos]->nome=(char*)malloc(strlen(&buf[sizeof(char)])+1);
strcpy(tabella_server[pos]->nome,&buf[sizeof(char)]);
tabella_server[pos]->addr=peeraddr_in.sin_addr.s_addr;
tabella_server[pos]->port=peeraddr_in.sin_port;
/*tabella_server[pos]->count=0;*/

/*Azzeramento del contatore degli accessi dei server della stessa classe
per non avere sbilanciamento nella distribuzione del carico*/
pos=0;
while((tabella_server[pos]!=NULL)&&(pos<NSERVMAX))
    {
    if (strcmp(&buf[1],tabella_server[pos]->nome)==0) tabella_server[pos]->count=0;
    pos++;
    }

/*Mando conferma di ricezione al server che ha chiesto la registrazione*/
strcpy (buf,"Ok1");
if((sendto(s,buf,(strlen(buf)+1),0,&peeraddr_in,sizeof(peeraddr_in)))==-1)
    {
    perror("regserver");
    fprintf(stderr,"Errore nella send di conferma in regserv()");
    exit(1); /*DEV: da modificare*/
    } 
}

/*Cerco il server nell'array di puntatori, quando l'ho trovato cerco l'ultimo server nella lista e lo copio nella posizione 
di quello vecchio*/
cancserv()
{
int pos=0,trovato= -1,fine=0;

while((pos<NSERVMAX)&&(!fine))
    {
    if (tabella_server[pos]!=NULL) 
	if((strcmp(&buf[sizeof(char)],tabella_server[pos]->nome)==0)&&(trovato==-1))
	        if (((tabella_server[pos]->addr)==(peeraddr_in.sin_addr.s_addr))&&((tabella_server[pos]->port)==(peeraddr_in.sin_port)))
		trovato=pos; /* In 'trovato' ho la posizione dell'elemento da sostituire*/
    if((tabella_server[pos]==NULL)&&(trovato!=-1)) /*Ovvero abbiamo raggiunto il primo elemento vuoto dell'array*/
	{
	if(tabella_server[1]==NULL)/*Ovvero l'elemento da togliere e' l'unico della lista e ha pos=0*/
	    {
	    /*Libero la memoria occupata*/
	    free(tabella_server[pos-1]->nome);
	    free(tabella_server[pos-1]);
	    tabella_server[pos-1]=NULL;
	    fine=1;
	    /*Notifico l'avvenuta cancellazione*/
	    strcpy (buf,"Ok2");
	    if((sendto(s,buf,(strlen(buf)+1),0,&peeraddr_in,sizeof(peeraddr_in)))==-1)
		{
        	perror("cancserver");
		fprintf(stderr,"Errore nella send di conferma in cancserv()");
		} 
	    }/*Fine if interno*/	
	    else
	    {	/*Copio le informazioni nella posizione che si e' svuotata*/
	    tabella_server[trovato]->port=tabella_server[pos-1]->port;
	    tabella_server[trovato]->addr=tabella_server[pos-1]->addr;
	    tabella_server[trovato]->count=tabella_server[pos-1]->count;
	    free(tabella_server[trovato]->nome); /* Perche' potrebbe avere una lunghezza differente*/
	    tabella_server[trovato]->nome=(char *)malloc(strlen((tabella_server[pos-1]->nome)+1));
	    /* Copio la stringa del nome*/
	    strcpy(tabella_server[trovato]->nome,tabella_server[pos-1]->nome);
	    /*Libero la memoria occupata*/
	    free(tabella_server[pos-1]->nome);
	    free(tabella_server[pos-1]);
	    tabella_server[pos-1]=NULL;
	    fine=1;
	    /*Notifico l'avvenuta cancellazione*/
	    strcpy (buf,"Ok2");
	    if((sendto(s,buf,(strlen(buf)+1),0,&peeraddr_in,sizeof(peeraddr_in)))==-1)
		{
        	perror("cancserver");
		fprintf(stderr,"Errore nella send di conferma in cancserv()");
		} 
	    }/*Fine else*/
	}/*Fine if*/
    pos++;
    }/*Fine While*/
}	


/*Il client richiede un nome logico del server, il gestore dei nomi restiruisce l'indirizzo IP e il numero di porta del server 
della classe richiesta con meno accessi*/
query_terminale()
{
int pos,trovato,adrlen;
trovato= -1;
pos=0;
adrlen=sizeof(myaddr_in.sin_addr.s_addr);
while ((pos<NSERVMAX)&&(tabella_server[pos]!=NULL))
    {
    if((strcmp(&buf[sizeof(char)],(tabella_server[pos]->nome)))==0)
	{
	if(trovato== -1) trovato=pos;/*Se e' il primo elemento trovato*/
	    else
	    if((tabella_server[pos]->count)<(tabella_server[trovato]->count)) 
		trovato=pos; /* Se non e' il primo si prende quello con accessi inferiori*/ 
	}
    pos++;
    }

/*Arrivo in questo punto quando ho trovato il server o se non lo ho trovato */
if(trovato!= -1)  
    {/*Trovato!*/
    /* Preparo il messaggio da spedire che conterra' l'indirizzo ip e il numero di porta*/
    tabella_server[trovato]->count++;
    memcpy(buf,&(tabella_server[trovato])->addr,sizeof(long int));
    /*buf[0]=(int *)(tabella_server[trovato])->addr;*/
    memcpy(&buf[sizeof(long int)],&(tabella_server[trovato])->port,sizeof(short int));
    /*buf[sizeof(long int)]=(unsigned short int  *)tabella_server[trovato]->port;*/
    sendto(s,buf,(sizeof(long int)+sizeof(short int)),0,&peeraddr_in,sizeof(peeraddr_in));
    }
    else  /*Nome sbagliato!!*/sendto(s,"Er3",4,0,&peeraddr_in,sizeof(peeraddr_in));
}	    



/*Funzione che comanda a tutti i server di una stessa classe di chiudere il database in lettura*/
/*Funzione che e' invocata dal server di scrittura nel caso non riesca ad aprire il file*/
int chiudi_dbf()
{
struct sockaddr_in remoteaddr_in;
int num=0,s2,addrlen;
char buf2[20],namefiliale[20];
int pos=0;

strcpy(namefiliale,&buf[1]);
addrlen=sizeof(struct sockaddr_in);
/*Apro una nuova socket per non generare confusione con eventuali richieste provenienti da altri
server o/e terminali*/

/*Assegniamo la porta di richiesta per la bind*/
myaddr_in.sin_port=htons(DNSPORT2);

/* Creazione della socket */
s2=socket(AF_INET,SOCK_DGRAM,0);
if (s2==-1)
    {
    perror("Chiudi DBF()");
    fprintf(stderr,"Non Posso creare la socket per il DNS\n");
    exit(1);
    }


/* Colleghiamo la socket all'indirizzo fisico DNSPORT2 */
if (bind(s2,&myaddr_in,sizeof(struct sockaddr_in))==-1)
    {
    perror(" impossibile eseguire il collegamento");
    exit(1);
    }
memset((char *)&remoteaddr_in,0,sizeof(struct sockaddr_in));
/* Riempiamo la struttura sockaddr per fermare i lettori*/
remoteaddr_in.sin_family=AF_INET;

buf2[0]='5';
while((pos<NSERVMAX)&&(tabella_server[pos]!=NULL))
    {
    if((strcmp(&buf[sizeof(char)],(tabella_server[pos]->nome)))==0)
	{/* Se il nome e' lo stesso, mando un comando di chiusura */
	num++;
	remoteaddr_in.sin_addr.s_addr=tabella_server[pos]->addr;
	remoteaddr_in.sin_port=tabella_server[pos]->port;
	vsprintf(&buf2[1],"%d",&pos);
	if((sendto(s2,buf2,(strlen(buf2)+1),0,&remoteaddr_in,sizeof(remoteaddr_in)))==-1)
	    {
	    perror("Chiudi_dbf");
	    fprintf(stderr,"Errore nella send di conferma\n");
	    return(-1);
	    }
	}
    pos++;
    }
/*Ricezione delle confereme, migliorabile  usando magari un array che
tenga traccia di chi ha risposto o meno*/
for (pos=0;pos<num;pos++)
   if((recvfrom(s2,buf,sizeof(buf),0,&remoteaddr_in,&addrlen))==-1)
		    { 
		    printf("Errore nella RECVFROM\n");
		    return(-1);
		    } 
/*Ora che ho ottenuto tutte le confereme posso dare via libera al server richiedente la scrittura*/
strcpy (buf,"Ok5");
if((sendto(s2,buf,(strlen(buf)+1),0,&peeraddr_in,sizeof(peeraddr_in)))==-1)
	{
    	perror("Conferma al server richiedente");
	fprintf(stderr,"Errore nella send di conferma in cancserv()");
	} 

/*Ora aspetto che l'operazione sia completata*/
if((recvfrom(s2,buf,sizeof(buf),0,&peeraddr_in,&addrlen))==-1)
	    { 
	    printf("Errore nella RECVFROM\n");
	    return(-1);
	    } 
pos=0;
/*Se la stringa ricevuta e' Start, riattivo i server*/
if(strcmp(buf,"Start")==0)
    {
    buf[0]='5';
    while((pos<NSERVMAX)&&(tabella_server[pos]!=NULL))
	{
	if((strcmp(namefiliale,(tabella_server[pos]->nome)))==0)
	    {/* Se il nome e' lo stesso, mando un comando di chiusura */
	    remoteaddr_in.sin_addr.s_addr=tabella_server[pos]->addr;
	    remoteaddr_in.sin_port=tabella_server[pos]->port;
	    strcpy(&buf[1],"Restart");
	    if((sendto(s2,buf,(strlen(buf)+1),0,&remoteaddr_in,sizeof(remoteaddr_in)))==-1)
		{
		perror("Riapri_dbf");
		fprintf(stderr,"Errore nella send di riapertura \n");
		return(-1);
		} 	  
	    }
	pos++;
	}/*Fine while*/    
    }/*Fine if*/
    else 
	{
	printf("Errore nella riapertura!!\n");
	exit(1);
	}
close(s2);		    
}






