/* terminaleUDP.c||  programma di interfacciamento con il NS e i vari server 
Thu Jan  7 16:01:38 1999*/
#define BUFSIZE 100
#define DNSPORT 32001
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <stdarg.h>
#include <string.h>

/*Struttura di memorizzazione dell'indirizzo
e host della filiale*/
typedef struct
    {
    unsigned long int addr;
    unsigned short int	port;
    } fil;

fil fil1;

    

int s,s2,lunghezza;
char scelta[5],nomefiliale[20],buf[BUFSIZE];

struct hostent *hp;
struct hostent *hostdns;

struct sockaddr_in dnsaddr_in;
struct sockaddr_in filialeaddr_in;

main (argc,argv)
int argc;char **argv;
{
int addrlen;

if (argc!=3)
    {
    fprintf(stderr,"Uso:%s  <server di nomi> <filiale di collegamento> \n",argv[0]);
    exit(1);
    }
/* Check sui parametri forniti in ingresso.*/
 /*check dell'esistenza del secondo parametro in /etc/hosts*/
if ((hostdns=gethostbyname(argv[1]))==NULL)
    {
    fprintf(stderr,"%s: %s non trovato in /etc/hosts\n",argv[0],argv[1]);
    fprintf(stderr,"Uso:%s  <server di nomi> <filiale di collegamento> \n",argv[0]);
    exit(1);
    }

/*Apro una socket e azzero la memoria*/
Imposta_DNS();
/*Copio il nome della filiale in un'altra stringa*/
strcpy(nomefiliale,argv[2]);
/*Interroghiamo l'utente su quello che vuole fare*/
for(;;)
    {
    
    crea_interfaccia();/*Funzione di creazione della maschera di richiesta*/
    scanf("%s",&scelta);
    switch (atoi(scelta))
	{
	case 1:visualizza();
		    break;
	case 2:inserisci();
		    break;
	case 3:del();
		    break;
	case 4:modifica();
		    break;
	case 5:cfiliale();
		    break;
	case 6:esci();
		    break;
	default:printf("Errore nella scelta, prego reimpostare\n");
		    sleep(1);
		    break;
	}
    }
    
/*Nel caso si arrivasse qui: ERRORE*/
printf("DEBUG: ERRORE NELLA ESECUZIONE\n");
} /*Fine MAIN*/


/*FUNZIONI DI SUPPORTO*/

crea_interfaccia()
{
printf("\n\n************* Filiale di %s  \n",nomefiliale);              
printf("************* Programma di gestione conto corrente *************\n\n");
printf("1- Visualizza conto corrente\n");
printf("2- Inserisci conto corrente\n");
printf("3- Cancella conto corrente\n");
printf("4- Modifica conto corrente\n");
printf("5- Seleziona filiale\n");
printf("6- ESCI\n");
printf("\n\nSelezione: ");
}



/*Routine di visualizzazione di un cliente della filiale specificata nella
variabile nomefiliale*/
int visualizza()
{
int totlen;
char buf2[20];
/*Vediamo se la filiale e' registrata*/
if(Interroga_DNS(nomefiliale)==-2)
	{
	printf("Filiale non registrata!!\n");
	return(-1);
	}
/*Ora nella struttura fil1 ho sia l'indirizzo della filiale che la sua porta*/
buf[0]='1';/*Seleziono la funzione di visualizzazione*/

/*Utilizzo come chiave di ricerca il cognome e il nome*/
printf("\n\n******************* Visualizza Cliente *******************\n\n");
printf("1) Inserire COGNOME e NOME del cliente: ");
scanf("%s %s",&buf[1],&buf2); /*Campo chiave*/

/*Preparo il buffer nella forma: Cognome+Nome+'\0'*/
strcat(buf,buf2);/*Cognome+Nome*/
totlen=strlen(buf)+1;/*Lunghezza del buffer da trasmettere*/


/* Riempiamo la struttura sockaddr per interrogare il server filiale in lettura*/
filialeaddr_in.sin_family=AF_INET;
filialeaddr_in.sin_addr.s_addr=fil1.addr;
filialeaddr_in.sin_port=fil1.port; /*Porta di ottenuta dal DNS*/

if (sendto(s,buf,totlen,0,&filialeaddr_in,sizeof(filialeaddr_in))==-1)
	{
	perror("Query terminata per errore");
	fprintf(stderr,"sulla richiesta alla filiale  %s \n",nomefiliale);
	exit(1);
	}

printf("Debug: messaggio  inviato\n");

/*Ricezione della risposta*/
if(recvfrom(s,buf,BUFSIZE,0,&filialeaddr_in,&lunghezza)==-1)
    {
    fprintf(stderr,"Errore nella ricezione della risposta\n");
    exit(1);
    }
/*Esaminiamo cosa abbiamo ottenuto*/
if(strcmp(buf,"Er1")==0)
    {
    printf("\nCliente  non presente nel database!!\n Reimpostare\n\n");
    sleep(1);
    return(-2);
    }
printf("\n\nL'ammontare del conto del cliente e': %s\n\n",buf);
sleep(1);
	
}

/*Inserimento cliente nella filiale specificata in nomefiliale+'W':
convenzione per identificare i server scrittori*/
inserisci()
{
char buf2[20];
int len,totlen,lenstr; 
/*Seleziono il server di scrittura della filiale considerata*/
strcat(nomefiliale,"W");
/*Vediamo se la filiale e' registrata*/
if(Interroga_DNS(nomefiliale)==-2)
	{
	printf("Filiale non registrata!!\n");
	len=strlen(nomefiliale);
	nomefiliale[len-1]='\0';
	return(-1);
	}
/*Ora nella struttura fil1 ho sia l'indirizzo della filiale che la sua porta*/	

/*Ripristino la stringa nomefiliale*/
len=strlen(nomefiliale);
nomefiliale[len-1]='\0';

/*Seleziono la funzione di inserimento*/
buf[0]='1';
/*Utilizzo come chiave di ricerca il cognome e il nome*/
printf("\n\n******************* Inserimento nuovo cliente *******************\n\n");
printf("1) Inserire COGNOME e NOME del cliente: ");
scanf("%s %s",&buf[1],&buf2); /*Campo chiave*/

/*Preparo il buffer nella forma: '1'+Cognome+Nome+'\0'+Conto+'\0'*/
strcat(buf,buf2);/*Cognome+Nome*/
totlen=strlen(buf)+1;/*Posizione dopo il terminatore*/

printf("2) Inserire ammontare del conto: ");
scanf("%s",&buf[totlen]);/*Campo dato*/
;/*Lunghezza del messaggio da inviare*/
lenstr=strlen(&buf[totlen]);
totlen=totlen+lenstr+1;/*Lunghezza totale dei dati da inviare*/

/* Riempiamo la struttura sockaddr per interrogare il server filiale in lettura*/
filialeaddr_in.sin_family=AF_INET;
filialeaddr_in.sin_addr.s_addr=fil1.addr;
filialeaddr_in.sin_port=fil1.port; /*Porta di ottenuta dal DNS*/


if (sendto(s,buf,totlen,0,&filialeaddr_in,sizeof(filialeaddr_in))==-1)
	{
	perror("Registrazione terminata per errore");
	fprintf(stderr,"sulla richiesta alla filiale  %s \n",nomefiliale);
	exit(1);
	}

printf("\n\n+++++++++ Registrazione in corso +++++++++\n");

/*Ricezione della risposta*/
if(recvfrom(s,buf,BUFSIZE,0,&filialeaddr_in,&lunghezza)==-1)
    {
    fprintf(stderr,"Errore nella ricezione della risposta\n");
    exit(1);
    }
/*Esaminiamo cosa abbiamo ottenuto*/
if(strcmp(buf,"Er1")==0)
    {
    printf("Cliente  gia' presente nel database!!\n Sceglire modifica\n\n");
    sleep(1);
    return(-2);
    }

}

/*Modifica l'ammontare del conto del cliente*/
modifica()
{
int totlen,len,lunstr;
char buf2[20],nomecliente[50];
/*Vediamo se la filiale e' registrata*/
if(Interroga_DNS(nomefiliale)==-2)
	{
	printf("Filiale non registrata!!\n");
	return(-1);
	}
/*Ora nella struttura fil1 ho sia l'indirizzo della filiale che la sua porta*/
buf[0]='1';/*Seleziono la funzione di visualizzazione*/

/*Utilizzo come chiave di ricerca il cognome e il nome*/
printf("\n\n******************* Modifica CC  *******************\n\n");
printf("1) Inserire COGNOME e NOME: ");
scanf("%s %s",&buf[1],&buf2); /*Campo chiave*/

/*Preparo il buffer nella forma: '1'+Cognome+Nome+'\0'*/
strcat(buf,buf2);/*Cognome+Nome*/
totlen=strlen(buf)+1;/*Lunghezza del buffer da trasmettere*/
strcpy(nomecliente,&buf[1]);

/* Riempiamo la struttura sockaddr per interrogare il server filiale in lettura*/
filialeaddr_in.sin_family=AF_INET;
filialeaddr_in.sin_addr.s_addr=fil1.addr;
filialeaddr_in.sin_port=fil1.port; /*Porta di ottenuta dal DNS*/

if (sendto(s,buf,totlen,0,&filialeaddr_in,sizeof(filialeaddr_in))==-1)
	{
	perror("Query terminata per errore");
	fprintf(stderr,"sulla richiesta alla filiale  %s \n",nomefiliale);
	exit(1);
	}

printf("Debug: messaggio  inviato\n");

/*Ricezione della risposta*/
if(recvfrom(s,buf,BUFSIZE,0,&filialeaddr_in,&lunghezza)==-1)
    {
    fprintf(stderr,"Errore nella ricezione della risposta\n");
    exit(1);
    }
/*Esaminiamo cosa abbiamo ottenuto*/
if(strcmp(buf,"Er1")==0)
    {
    printf("Cliente  non presente nel database!!\n Reimpostare\n\n");
    sleep(1);
    return(-2);
    }
/*Visualizziamo cosa  abbiamo ottenuto*/
printf("\n\nL'ammontare del conto del cliente e': %s\n\n",buf);

/*INSERIMENTO*/

/*Seleziono il server della filiale considerata per la scrittura*/
strcat(nomefiliale,"W");
/*Vediamo se la filiale e' registrata*/
if(Interroga_DNS(nomefiliale)==-2)
	{
	printf("Filiale non registrata!!\n");
	len=strlen(nomefiliale);
	nomefiliale[len-1]='\0';
	return(-1);
	}
/*Ora nella struttura fil1 ho sia l'indirizzo della filiale che la sua porta*/	

/*Ripristino la stringa nomefiliale*/
len=strlen(nomefiliale);
nomefiliale[len-1]='\0';

/*Preparo il buffer nella forma: '3'+Cognome+Nome+'\0'+Conto+'\0'*/
buf[0]='3';/*operazione di replace*/
strcpy(&buf[1],nomecliente);
totlen=strlen(buf)+1;/*Posizione dopo il terminatore*/

printf("Inserire nuovo ammontare del conto: ");
scanf("%s",&buf[totlen]);/*Campo dato*/
;/*Lunghezza del messaggio da inviare*/
lunstr=strlen(&buf[totlen]);
totlen=totlen+lunstr+1;/*Lunghezza totale dei dati da inviare*/


/* Riempiamo la struttura sockaddr per modificare il dato*/
filialeaddr_in.sin_family=AF_INET;
filialeaddr_in.sin_addr.s_addr=fil1.addr;
filialeaddr_in.sin_port=fil1.port; /*Porta di ottenuta dal DNS*/


if (sendto(s,buf,totlen,0,&filialeaddr_in,sizeof(filialeaddr_in))==-1)
	{
	perror("Registrazione terminata per errore");
	fprintf(stderr,"sulla richiesta alla filiale  %s \n",nomefiliale);
	exit(1);
	}

printf("\n\n+++++++++ Registrazione in corso +++++++++\n");

/*Ricezione della risposta*/
if(recvfrom(s,buf,BUFSIZE,0,&filialeaddr_in,&lunghezza)==-1)
    {
    fprintf(stderr,"Errore nella ricezione della risposta\n");
    exit(1);
    }
/*Esaminiamo cosa abbiamo ottenuto*/
if(strcmp(buf,"Er3")==0)
    {
    printf("Operazione non riuscita!!\n");
    sleep(1);
    return(-2);
    }
}


/*Cambiamento di filiale attiva*/
cfiliale()
{
printf("Inserisci NOME della nuova filiale a cui collegarsi: ");
scanf("%s",buf);
strcpy(nomefiliale,buf);
sleep(1);
}


/*Cancellazione cliente*/
int del()
{
char buf2[20];
int len,totlen; 
/*Seleziono il server della filiale considerata per la scrittura*/
strcat(nomefiliale,"W");
/*Vediamo se la filiale e' registrata*/
if(Interroga_DNS(nomefiliale)==-2)
	{
	printf("Filiale non registrata!!\n");
	len=strlen(nomefiliale);
	nomefiliale[len-1]='\0';
	return(-1);
	}
/*Ora nella struttura fil1 ho sia l'indirizzo della filiale che la sua porta*/	

/*Ripristino la stringa nomefiliale*/
len=strlen(nomefiliale);
nomefiliale[len-1]='\0';

/*Seleziono l'operazione di cancellazione*/
buf[0]='2';
/*Utilizzo come chiave di ricerca il cognome e il nome*/
printf("\n\n******************* Cliente da rimuovere *******************\n\n");
printf("1) Inserire COGNOME e NOME: ");
scanf("%s %s",&buf[1],&buf2); /*Campo chiave*/

/*Preparo il buffer nella forma: '2'+Cognome+Nome+'\0'*/
strcat(buf,buf2);/*Cognome+Nome*/
totlen=strlen(buf)+1;/*Posizione dopo il terminatore*/


/* Riempiamo la struttura sockaddr per interrogare il server filiale in lettura*/
filialeaddr_in.sin_family=AF_INET;
filialeaddr_in.sin_addr.s_addr=fil1.addr;
filialeaddr_in.sin_port=fil1.port; /*Porta di ottenuta dal DNS*/


if (sendto(s,buf,totlen,0,&filialeaddr_in,sizeof(filialeaddr_in))==-1)
	{
	perror("Registrazione terminata per errore");
	fprintf(stderr,"sulla richiesta alla filiale  %s \n",nomefiliale);
	exit(1);
	}

printf("\n\n+++++++++ Cancellazione in corso +++++++++\n");

/*Ricezione della risposta*/
if(recvfrom(s,buf,BUFSIZE,0,&filialeaddr_in,&lunghezza)==-1)
    {
    fprintf(stderr,"Errore nella ricezione della risposta\n");
    exit(1);
    }
/*Esaminiamo cosa abbiamo ottenuto*/
if(strcmp(buf,"Er2")==0)
    {
    printf("\n++++++++++ Cliente  non presente nel database!!\n\n");
    sleep(1);
    return(-2);
    }
    else
	{
	printf("\n\n++++++++++ Cancellazione effettuata\n\n");
	}
}

esci()
{
exit(0);
}

/*Funzione che prende in ingresso una stringa che e' il nome  della filiale e restituisce 
l'indirizzo IP della filiale richiesta dopo avere interrogato il DNS*/
int Interroga_DNS(filiale)  
char* filiale;
{

unsigned long int indirizzo1;
int lunghezza,i,j,porta;
/* Invio richiesta*/
/*La socket e' stata gia' aperta ed e' s*/
buf[0]='3'; /*Scelgo di richiedere al DNS la funzione 3 che corrisponde alla query*/
strcpy(&buf[1],filiale);
if (sendto(s,buf,(strlen(buf)+1),0,&dnsaddr_in,sizeof(dnsaddr_in))==-1)
	{
	perror("Query terminata per errore");
	fprintf(stderr,"sulla richiesta al DNS del server: %s\n",filiale);
	exit(1);
	}

printf("Debug: messaggio  inviato\n");

/*Ricezione del messaggio dal NS contenente indirizzo IP e porta*/
if (recvfrom(s,buf,BUFSIZE,0,&dnsaddr_in,&lunghezza)==-1)
    {
    perror("Errore in ricezione dal DNS");
    fprintf(stderr,"sulla richiesta al DNS del server: %s\n",filiale);
    exit(1);
    }

/*Esaminiamo il buffer ricevuto*/
if (strcmp("Er3",buf)==0)
    {
    printf("Nome della filiale non registrato sul DNS\n");
    return (-2);
    }

/*Assegnazione dell'indirizzo alla variabile fil1*/
memcpy(&fil1.addr,buf,sizeof(long int));
memcpy(&fil1.port,&buf[sizeof(long int)],sizeof(short int));
return(1);
}




/*Imposta la connessione con il DNS*/
Imposta_DNS()
{
/* Azzeriamo le strutture degli indirizzi allocate staticamente*/
memset((char *)&dnsaddr_in,0,sizeof(struct sockaddr_in));
memset((char *)&filialeaddr_in,0,sizeof(struct sockaddr_in));


/* Riempiamo la struttura sockaddr per interrogare il DNS*/
dnsaddr_in.sin_family=AF_INET;
dnsaddr_in.sin_addr.s_addr=((struct in_addr *)(hostdns->h_addr))->s_addr;
dnsaddr_in.sin_port=htons(DNSPORT); /*Porta di default del DNS*/

/* Creazione della socket */
s=socket(AF_INET,SOCK_DGRAM,0);
if (s==-1)
    {
    perror("Imposta_DNS()");
    fprintf(stderr,"Non Posso creare la socket per il DNS\n");
    exit(1);
    }
}
